<script setup>
import useVuelidate from "@vuelidate/core";
import { required } from "@vuelidate/validators";
import { computed, onMounted, reactive, ref } from "vue";
import { useStore } from "vuex";
import { useRouter, useRoute } from "vue-router";
import * as chartConfig from "@/components/Charts/chart.config.js";
import CheckRadioPicker from "@/components/CheckRadioPicker.vue";
import TitleBar from "@/components/TitleBar.vue";
import HeroBar from "@/components/HeroBar.vue";
import CardWidget from "@/components/CardWidget.vue";
import JbButtons from "@/components/JbButtons.vue";
import JbButton from "@/components/JbButton.vue";
import StaffComponent from "@/components/StaffComponent.vue";
import SearchBox from "@/components/SearchBox.vue";
import FilterBox from "@/components/FilterBox.vue";
import ModalBox from "@/components/ModalBox.vue";
import Institute from "@/api/institute";
import { useToast } from "vue-toastification";
import Staff from "@/api/staff";
import { data } from "autoprefixer";
const lightBorderStyle = computed(() => store.state.lightBorderStyle);
const lightBgStyle = computed(() => store.state.lightBgStyle);
const searchText = ref("");
const router = useRouter();
const route = useRoute();
const toast = useToast();
const store = useStore();
const titleStack = ref(["StaffList"]);
const chartData = ref(null);
const fillChartData = () => {
  chartData.value = chartConfig.sampleChartData();
};
const keyValue = ref(false);
const id = ref(route.params.instituteId);
// const staffid = ref(route.params.staffId);
const staffList = reactive({ value: {} });
var staffData = reactive({ value: [] });
var hospitalList = reactive({ value: [] });
var paginationList = reactive({ value: {} });
const order = ref(-1);
const field = ref("name");
const fieldSearch = ref("");
const currentPage = ref(1);
onMounted(() => {
  loadPage({
    searchText: fieldSearch.value,
    page: currentPage.value,
    orderBy: field.value,
    orderIn: order.value,
  });
});

const hospitalitems = computed(() => {
  return hospitalList.value;
});
const staffitems = computed(() => {
  return staffList.value;
});
// View Single Hospital Details
const setCurrentHospital = (insititutes) => {
  store.commit("setCurrentHospital", { insititutes: insititutes });
};
const loadPage = ({ searchText, page, orderBy, orderIn }) => {
  if (orderIn) {
    console.log("orderIn");
    if (order.value == 1) {
      order.value = -1;
    } else {
      order.value = 1;
    }
  }
  if (searchText) {
    fieldSearch.value = searchText;
  }
  if (page) {
    currentPage.value = page;
  }
  if (orderBy) {
    field.value = orderBy;
  }

  console.log("pagenumber", page);
  Institute.get(id.value).then((data) => {
    hospitalList.value = data?.data?.insititutes;
    console.log("hospitalList", hospitalList);
    paginationList.value = data?.data?.pagination;
    console.log("paginationList", paginationList.value);
  });
  Staff.get({
    instituteId: id.value,
    searchText: fieldSearch.value,
    page: currentPage.value,
    orderBy,
    orderIn: order.value,
  }).then((data) => {
    staffList.value = data?.data?.staffs;
    paginationList.value = data?.data?.pagination;
    console.log("stffResult", data?.data?.staffs);
    console.log("staffList", staffList.value);
  });
};
const staffs = reactive({ staff: "" });
// Delete Institute
const delStaff = (staff) => {
  staffs.staff = staff;
  console.log("line106", staffs.staff);
  isModalDangerActive.value = true;
};
const del = async (id, staffId) => {
  Staff.delete(id, staffId)
    .then((data) => {
      console.log("pass?.success", data?.success);
      if (data?.success) {
        toast.success(data?.message);
        isModalDangerActive.value = false;
        loadPage({
          searchText: fieldSearch.value,
          page: currentPage.value,
          orderBy: field.value,
          orderIn: order.value,
        });
      } else {
        toast.error(data?.message);
      }
    })
    .catch((error) => {
      let message =
        error?.response?.data?.message || "something wrong! please try again";
      toast.error(message);
    });
};
// onMounted(() => {
//   fillChartData();
// });
const isModalActive = ref(false);
const isModalDangerActive = ref(false);
const darkMode = computed(() => store.state.darkMode);
const staffAddBy = reactive({
  value: "",
});
// Validation
const rules = computed(() => {
  return {
    value: { required },
  };
});
const v$ = useVuelidate(rules, staffAddBy);
const AddStaffBy = () => {
  v$.value.$validate();
  // if success
  if (!v$.value.$error) {
    isModalActive.value = false;
    router.push(`/add-staff/${id.value}`);
  }
};
const customElementsForm = reactive({
  checkbox: ["lorem"],
  radio: "one",
  switch: ["one"],
  file: null,
});
</script>
<template>
  <Transition :duration="{ enter: 500, leave: 800 }" name="nested">
    <modal-box
      v-model="isModalActive"
      title="&nbsp;"
      button="danger"
      has-cancel
    >
      <h2 class="text-center my-4">ADD STAFF</h2>
      <div class="border-0 shadow-none md:flex py-6">
        <check-radio-picker
          v-model="staffAddBy.value"
          name="sample-radio"
          type="radio"
          class="flex justify-between text-xs"
          :options="{ one: 'Add Staff Manually', two: 'Add Staff via Sheet' }"
        />
      </div>
      <p class="text-pink-250 pl-2 text-sm text-left" v-if="v$.value.$error">
        Please select any option
      </p>
      <div class="py-6 text-sm">
        <jb-buttons class="flex justify-around">
          <jb-button
            color="light"
            label="No"
            @click="isModalActive = false"
            class="rounded-lg px-10 py-3"
            :small="buttonsSmall"
            :outline="buttonsOutline"
            :disabled="buttonsDisabled"
          />

          <jb-button
            class="text-white bg-pink-250 hover:bg-pink-250 rounded-lg px-10 py-3"
            label="Yes"
            @click="AddStaffBy"
            :small="buttonsSmall"
            :outline="buttonsOutline"
            :disabled="buttonsDisabled"
          />
        </jb-buttons>
      </div> </modal-box
  ></Transition>
  <section class="bg-gray-40 py-10">
    <span class="flex justify-between w-full text-sm pt-2">
      <!-- <title-bar :title-stack="titleStack" class="text-sm" /> -->
      <hero-bar>StaffList</hero-bar>
    </span>
    <section class="px-0 md:px-6 py-6">
      <span class="md:flex justify-between w-full mb-2">
        <div class="md:w-2/3 w-full flex">
          <div
            class="relative text-gray-600 focus-within:text-gray-400 md:w-1/2 w-full"
          >
            <span class="absolute flex items-center pl-2 py-2">
              <button
                type="submit"
                class="p-1 focus:outline-none focus:shadow-outline"
              >
                <svg
                  fill="none"
                  stroke="currentColor"
                  stroke-linecap="round"
                  stroke-linejoin="round"
                  stroke-width="2"
                  viewBox="0 0 24 24"
                  class="w-4 h-4"
                >
                  <path d="M21 21l-6-6m2-5a7 7 0 11-14 0 7 7 0 0114 0z"></path>
                </svg>
              </button>
            </span>
            <input
              v-model="fieldSearch"
              @input="loadPage({})"
              type="search"
              class="h-10 py-2.5 hover:border active:border active:text-pink-250 shadow-sm w-full text-sm text-gray-250 border-0 border-gray-150 bg-white rounded-full pl-10 focus:outline-none focus:border-pink-40 focus:ring-1 focus:ring-pink-250 focus:bg-white focus:text-gray-900"
              placeholder="Search..."
              autocomplete="off"
            />
          </div>
          <!-- Filter Start -->
          <div class="group inline-block ml-4 md:w-1/2 w-full">
            <button
              class="outline-none focus:outline-none border-0 px-4 py-2 bg-white rounded-full flex text-gray-400 items-center min-w-40"
            >
              <img src="@/assets/icons/filter-icon.svg" />
              <span class="pr-4 pl-2 font-semibold flex-1">Sort By</span>
              <span>
                <svg
                  class="fill-current h-4 w-4 transform group-hover:-rotate-180 transition duration-150 ease-in-out"
                  xmlns="http://www.w3.org/2000/svg"
                  viewBox="0 0 20 20"
                >
                  <path
                    d="M9.293 12.95l.707.707L15.657 8l-1.414-1.414L10 10.828 5.757 6.586 4.343 8z"
                  />
                </svg>
              </span>
            </button>
            <ul
              class="bg-white w-28 border rounded-sm transform scale-0 group-hover:scale-100 absolute transition duration-150 ease-in-out origin-top text-sm z-10 mt-1"
            >
              <li
                class="rounded-sm px-4 py-1 hover:bg-gray-100 cursor-pointer border-b"
                @click.prevent="
                  loadPage({
                    searchText: 'doctor',
                  })
                "
              >
                Doctor
              </li>
              <li
                class="rounded-sm px-4 py-1 hover:bg-gray-100 cursor-pointer"
                @click="
                  loadPage({
                    searchText: 'nurse',
                  })
                "
              >
                Nurse
              </li>
              <!-- <li
                class="rounded-sm px-2 py-1 hover:bg-gray-100 cursor-pointer"
                @click="loadPage({ orderBy: 'profession', orderIn: 1 })"
              >
                High Risk Patient
              </li>
              <li class="rounded-sm px-2 py-1 hover:bg-gray-100 cursor-pointer">
                Invited Link Expired
              </li> -->
            
            </ul>
          </div>
          <!-- Filter End -->
        </div>
        <jb-button
          class="btnColor hover:bg-pink-250 pl-4 md:mt-0 mt-4"
          label="Add Staff"
          @click="isModalActive = true"
          :small="buttonsSmall"
          :outline="buttonsOutline"
          :disabled="buttonsDisabled"
        />
      </span>
      <div
        class="grid grid-cols-1 md:grid-cols-2 xl:grid-cols-3 gap-6 mb-6 mt-6"
      >
        <TransitionGroup name="fade">
          <staff-component
            v-for="staff in staffList.value"
            :key="staff.staffId"
            class="mb-6 mt-4 bg-white rounded-lg"
            hoverable
          >
            <level
              class="flex justify-between bg-pink-60 px-3 py-1 rounded-t-lg"
            >
              <router-link
                :to="{
                  name: 'staff-detail',
                  params: { instituteId: id, staffId: staff.staffId },
                }"
              >
                <level class="justify-start flex pt-2">
                  <img
                    class="w-12 h-12 md:mr-6"
                    src="@/assets/icons/user-pic.svg"
                    alt="pic"
                  />
                  <div class="text-center flex-wrap md:text-left font-semibold">
                    <h4 class="text-base capitalize">
                      {{ staff.firstName }} {{ staff.middleName }}
                      {{ staff.lastName }}
                    </h4>
                    <p class="text-gray-250 dark:text-gray-400 capitalize">{{ staff.profession }}</p>
                  </div>
                </level>
              </router-link>
              <div class="flew">
                <div class="group inline-block">
                  <button
                    class="outline-none focus:outline-none px-4 py-2 flex text-gray-400"
                  >
                    <img src="@/assets/icons/vertical_dot.svg" />
                  </button>
                  <ul
                    class="rounded-lg bg-white border transform scale-0 group-hover:scale-100 absolute transition duration-150 ease-in-out origin-top text-sm -ml-20 z-10 mt-1 w-40"
                  >
                    <li
                      class="rounded-sm p-2 hover:bg-gray-100 cursor-pointer flex"
                    >
                      <router-link
                        class="flex"
                        :to="{
                          name: 'edit-staff',
                          params: { instituteId: id, staffId: staff.staffId },
                        }"
                      >
                        <img class="mr-2" src="@/assets/icons/pink-dot.svg" />
                        Edit Profile
                      </router-link>
                    </li>
                    <li
                      class="rounded-sm p-2 hover:bg-gray-100 cursor-pointer flex"
                    >
                      <img class="mr-2" src="@/assets/icons/pink-dot.svg" />
                      Make an Admin
                    </li>
                    <li
                      @click="delStaff(staff)"
                      class="rounded-sm p-2 hover:bg-gray-100 cursor-pointer flex"
                    >
                      <img class="mr-2" src="@/assets/icons/pink-dot.svg" />
                      Remove from Institution
                    </li>
                  </ul>
                  <!-- Delete Confirmation Modal -->
                  <Transition
                    :duration="{ enter: 500, leave: 800 }"
                    name="nested"
                  >
                    <modal-box
                      v-model="isModalDangerActive"
                      title="&nbsp;"
                      button="danger"
                      has-cancel
                    >
                      <h1 class="my-2 text-lg">Please confirm</h1>
                      <p class="my-2 text-base">
                        Are you sure you want to delete this Staff?
                      </p>
                      <div class="py-6 text-sm">
                        <jb-buttons class="flex justify-center">
                          <jb-button
                            color="light"
                            label="No"
                            @click="isModalDangerActive = false"
                            class="rounded-lg px-4 py-2 text-pink-250 border-pink-250 bg-pink-40 mr-4"
                            :small="buttonsSmall"
                            :outline="buttonsOutline"
                            :disabled="buttonsDisabled"
                          />

                          <jb-button
                            class="text-white bg-pink-250 hover:bg-pink-250 rounded-lg px-4 py-2 ml-4"
                            label="Yes"
                            @click="del(id, (Stid = staffs.staff.staffId))"
                            :small="buttonsSmall"
                            :outline="buttonsOutline"
                            :disabled="buttonsDisabled"
                          />
                        </jb-buttons>
                      </div>
                    </modal-box>
                  </Transition>
                  <!-- Delete Confirmation Modal -->
                </div>
                <img
                  src="@/assets/icons/Call_icon.svg"
                  class="mr-0 cursor-pointer"
                />
              </div>
            </level>
            <div
              class="grid grid-cols-1 xl:grid-cols-3 gap-2 font-semibold mt-2 bg-white text-sm rounded-b-lg p-4"
            >
              <div class="text-black-250">Email</div>
              <div class="text-gray-400 col-span-2">{{ staff.email }}</div>
              <div class="text-black-250">Phone No.</div>
              <div class="text-gray-400 col-span-2">{{ staff.mobile }}</div>
              <div class="text-black-250">Profession</div>
              <div class="text-gray-400 col-span-2">{{ staff.profession }}</div>

              <div class="text-black-250">Initial</div>
              <div class="text-gray-400">{{ staff.initials }}</div>
              <div class="justify-end flex">
                <span class="text-green-500" v-if="staff.isOnDuty == true">
                  on Duty
                </span>
                <span class="text-red-500" v-else> Off Duty </span>
              </div>
            </div>
          </staff-component>
        </TransitionGroup>
      </div>
      <div
        v-if="paginationList.value"
        :class="lightBorderStyle"
        class="px-3 py-6 lg:px-6 border-t dark:border-gray-800"
      >
        <level class="flex justify-between">
          <small
            >Page {{ paginationList.value?.currentPage }} of
            {{ paginationList.value?.totalPages }}</small
          >
          <jb-buttons>
            <jb-button
              v-for="(n, index) in paginationList.value?.totalPages"
              :key="index"
              :active="n === paginationList.value?.currentPage"
              :label="n"
              :outline="darkMode"
              class="focus:bg-pink-250 w-8 h-8 text-sm hover:bg-pink-250 focus:outline-none active:border-0 active:bg-pink-250 focus:border-0 focus:ring-1 active:ring-1 active:ring-pink-250 focus:ring-pink-250 focus:text-white"
              small
              @click="loadPage({ page: n })"
            />
          </jb-buttons>
        </level>
      </div>
    </section>
  </section>
</template>
